<?php


namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Service\AclLabels as AclLabelsService;

class AclLabels
{
    use TResponse;

    /**
     * @var AclLabelsService
     */
    private $aclLabelsService;

    public function __construct(AclLabelsService $aclLabelsService)
    {
        $this->aclLabelsService = $aclLabelsService;
    }

    public function findAclLabelsByProject(Request $request)
    {
        try {
            $projectId = $request->getParameter('projectId');
            $aclLabels = $this->aclLabelsService->findAclLabelsByProject($projectId);
            $this->sendResponse($aclLabels, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }

    public function saveAclLabelsByProject(Request $request)
    {
        try {
            $projectId = $request->getParameter('projectId');
            $labelsFile = $request->getParameter('labelsFile');
            $saveLog = $request->getParameter('saveLog');
            $aclLabels = $this->aclLabelsService->saveAclLabelsByProject($projectId, $labelsFile, $saveLog);
            $this->sendResponse($aclLabels, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }

    public function findAclLabelsLogByProject(Request $request)
    {
        try {
            $params = $request->getParameters();
            $aclLabels = $this->aclLabelsService->findAclLabelsLogByProject($params);

            $this->sendResponse($aclLabels, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }
}
