import { ZdPage } from '@zeedhi/vue';
import { ZdFramePage } from '@zeedhi/vuetify';

const routes = [
	{
		path: '/test',
		name: 'test',
		component: ZdFramePage,
		props: () => ({
			type: 'post',
			params: {
				jsonPath: 'test',
				routePath: '/test',
			},
		}),
	},
	{
		path: '/auth/login',
		name: 'login',
		component: ZdPage,
		props: () => ({
			path: 'login',
			local: true,
		}),
	},
	{
		path: '/gestao-de-demandas-test',
		component: ZdPage,
		name: 'demandManagement-test',
		props: {
			path: 'demandManagement/tabCall',
			local: true,
		},
	},
	{
		path: '/organization',
		component: ZdFramePage,
		name: 'organization',
		props: {
			path: 'organization/organization',
			local: true,
		},
	},
	{
		path: '/structureConfiguration',
		component: ZdFramePage,
		name: 'structureConfiguration',
		props: {
			path: 'structureConfiguration/structureConfiguration',
			local: true,
		},
	},
	{
		path: '/documentsTemplate',
		component: ZdFramePage,
		name: 'documentsTemplate',
		props: {
			path: 'documentsTemplate/documentsTemplate',
			local: true,
		},
	},
	{
        path: '/',
        name: 'home',
        component: ZdPage,
        props: () => ({
            path: 'home',
            local: true,
        }),
    },
    {
        path: '/gestao-de-demandas',
        component: ZdFramePage,
        name: 'demandManagement',
        props: {
            type: 'post',
			params: {
				jsonPath: 'demandManagement/tabCall',
				routePath: '/gestao-de-demandas',
			},
        },
    },
	{
        path: '/taskTracking',
        component: ZdFramePage,
        name: 'taskTracking',
        props: {
            type: 'post',
			params: {
				jsonPath: 'taskTracking/taskTracking',
				routePath: '/taskTracking',
			},
        },
    },
    {
        path: '/item-de-trabalho',
        component: ZdFramePage,
        name: 'item-de-trabalho',
        props: () => ({
			type: 'post',
			params: {
				jsonPath: 'workItem/workItem',
				routePath: '/item-de-trabalho',
			},
		}),
    },
	{
		path: '/acl-labels',
		component: ZdPage,
		name: 'acl-labels',
		props: {
			path: 'aclLabels/aclLabels',
			local: true,
		},
	},
    {
        path: '/issue-Labels',
        component: ZdFramePage,
        name: 'issue-Labels',
        props: () => ({
			type: 'post',
			params: {
				jsonPath: 'issueLabels/issueLabels',
				routePath: '/issue-Labels',
			},
		}),
    },
    {
        path: '/valoresOrcaCli',
        component: ZdFramePage,
        name: 'valoresOrcaCli',
        props: {
            type: 'post',
			params: {
				jsonPath: 'valoresOrcaCli/valoresOrcaCli',
				routePath: '/valoresOrcaCli',
			},
        },
    },
    {
        path: '/modules/:module/:page',
        name: 'microservice',
        component: () => import('../views/Microservice.vue'),
    },
    {
        path: '*',
        component: ZdPage,
        props: {
            path: 'notfound',
            local: true,
        },
    },
];

export default routes;
